#include <stdio.h>

//funkcija koja radi s 1d poljima (pokazivacima na double) pa pri pozivu koristimo castanje
void ispis(double x[], int maxj, int m, int n)
{
    int i, j;

    for(i=0; i<m; i++){
        for(j=0; j<n; j++){
            printf("%g ", *(x+i*maxj+j));
        }
        printf("\n");
    }
    printf("\n");
}

void ispis_matrica(double x[][3], int m, int n)
{
    int i, j;

    for(i=0; i<m; i++){
        for(j=0; j<n; j++){
            printf("%g ", x[i][j]);
        }
        printf("\n");
    }
    printf("\n");
}


//funkcija koja radi s 1d poljima (pokazivacima na double) pa pri pozivu koristimo castanje
int f(double x[], int maxj, int m, int n)
{
    int i, j, pr, nenul, minj=-1, min;

    for(j=0; j<n; j++){
        pr=1;
        nenul=0;
        for(i=0; i<m; i++){
            if(x[i*maxj+j]){
                pr*=x[i*maxj+j];
                nenul=1;
            }
        }
        if(!nenul)
            continue;

        if(minj==-1 || pr<min){
            min=pr;
            minj=j;
        }
    }

    if(minj>-1){
        for(i=0; i<m; i++)
            printf("%g\n", x[i*maxj+minj]);
    }
    printf("\n");
}

int f_matrica(double x[][3], int m, int n)
{
    int i, j, pr, nenul, minj=-1, min;

    for(j=0; j<n; j++){
        pr=1;
        nenul=0;
        for(i=0; i<m; i++){
            if(x[i][j]){
                pr*=x[i][j];
                nenul=1;
            }
        }
        if(!nenul)
            continue;

        if(minj==-1 || pr<min){
            min=pr;
            minj=j;
        }
    }

    if(minj>-1){
        for(i=0; i<m; i++)
            printf("%g\n", x[i][minj]);
    }
    printf("\n");
}

int main(void)
{
    //double x[][3]={{1,2,3},{4,5,6},{7,8,9}};
    double x[][3]={{0,2,3},{0,5,6},{0,8,9}};

    ispis((double*)x,3,3,3);
    f((double*)x,3,3,3);

	ispis_matrica(x,3,3);
	f_matrica(x,3,3);

    return 0;
}
